﻿using System.Runtime.InteropServices;
using UPNPLib;


namespace Sat2Ip.Library.Upnp
{
    [ComVisible(true), ComImport,
    Guid("415A984A-88B3-49F3-92AF-0508BEDF0D6C"),
    InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    internal interface IUPnPDeviceFinderCallback
    {
        [PreserveSig]
        int DeviceAdded([In] int lFindData,
       [In] IUPnPDevice pDevice);

        [PreserveSig]
        int DeviceRemoved([In] int lFindData,
       [In] string bstrUDN);

        [PreserveSig]
        int SearchComplete([In] int lFindData);
    }
    public class DeviceCollector : IUPnPDeviceFinderCallback
    {
        private UPnPDeviceFinderClass _finder;
        private int _SearchId;

        public delegate void DeviceAddedEventHandler(UPnPDevice addeddevice);
        public delegate void DeviceRemovedEventHandler(string sUDN);
        public delegate void SearchCompletedEventHandler();

        public event DeviceAddedEventHandler DeviceAdded;
        public event DeviceRemovedEventHandler DeviceRemoved;
        public event SearchCompletedEventHandler SearchCompleted;


        public DeviceCollector()
        {
            _finder = new UPnPDeviceFinderClass();
            _SearchId = _finder.CreateAsyncFind("urn:ses-com:device:SatIPServer:1", 0, this);
            _finder.StartAsyncFind(_SearchId);
        }
        
        ~DeviceCollector()
        {
            
        }


        #region IUPnPDeviceFinderCallback Members

        int IUPnPDeviceFinderCallback.DeviceAdded(int lFindData, IUPnPDevice pDevice)
        {
            DeviceAdded((UPnPDevice)pDevice);
            return 0;
        }

        int IUPnPDeviceFinderCallback.DeviceRemoved(int lFindData, string bstrUDN)
        {
            DeviceRemoved(bstrUDN);
            return 0;
        }

        int IUPnPDeviceFinderCallback.SearchComplete(int lFindData)
        {
            SearchCompleted();
            return 0;
        }

        #endregion
    }
}
