﻿using System.ComponentModel;

namespace Sat2Ip.UI.RtspSample
{
    public class Service : INotifyPropertyChanged
    {
        #region Private Fields

        private string _name;
        private string _source;
        private string _frequency;
        private string _symbolRate;
        private string _polarity;
        private string _system;
        private string _pids;
        private string _frontEnd;

        #endregion

        #region Constructor

        public Service()
        { }
        public Service(string name, string source,string frontEnd, string frequency, string symbolrate, string polarity, string system, string pids)
        {
            _name = name;
            _source = source;
            _frontEnd = frontEnd;
            _frequency = frequency;
            _symbolRate = symbolrate;
            _polarity = polarity;
            _system = system;
            _pids = pids;
        }

        #endregion

        #region Properties

        public string Source
        {
            get { return _source; }
            set
            {
                if (_source != value)
                {
                    _source = value;
                    OnPropertyChanged("Source");
                }
            }
        }
        public string FrontEnd
        { 
            get { return _frontEnd; }
            set{
                if (_frontEnd != value)
                {
                    _frontEnd = value;
                    OnPropertyChanged("FrontEnd");
                }
            } 
        }
        public string Frequency
        {
            get { return _frequency; }
            set
            {
                if (_frequency != value)
                {
                    _frequency = value;
                    OnPropertyChanged("Frequency");
                }
            }
        }
        public string SymbolRate
        {
            get { return _symbolRate; }
            set
            {
                if (_symbolRate != value)
                {
                    _symbolRate = value;
                    OnPropertyChanged("SymbolRate");
                }
            }
        }
        public string Polarity
        {
            get { return _polarity; }
            set
            {
                if (_polarity != value)
                {
                    _polarity = value;
                    OnPropertyChanged("Polarity");
                }
            }
        }
        public string System
        {
            get { return _system; }
            set
            {
                if (_system != value)
                {
                    _system = value;
                    OnPropertyChanged("System");
                }
            }
        }
        public string Pids
        {
            get { return _pids; }
            set
            {
                if (_pids != value)
                {
                    _pids = value;
                    OnPropertyChanged("Pids");
                }
            }
        }

        #endregion

        #region Public Events

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region Protected Methods

        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }

        #endregion

        #region Public Overrides

        public override string ToString()
        {
            return string.Format("src={0}fe={1}&freq={2}&sr={3}&pol={4}&msys={5}&pids={6}", _source,_frontEnd, _frequency, _symbolRate, _polarity, _system, _pids);
        }

        #endregion
    }
}